#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include "hashmap.h"

void print_capital_city(struct hashmap_t *hashmap,
			K key) {
  V value;  
  if(hashmap_get(hashmap, key, value))
    printf("Capital of %s is %s\n", key, value);
  else
    printf("Cannot find the Capital of %s\n", key);
}

int main() {
  struct hashmap_t hashmap;

  printf("# Testing hashmap_init\n");
  hashmap_init(&hashmap);

  printf("# Testing hashmap_put\n");

  hashmap_put(&hashmap, "Chine", "Pékin");
  hashmap_put(&hashmap, "Japon", "Tokyo");
  hashmap_put(&hashmap, "République démocratique du Congo", "Kinshasa");
  hashmap_put(&hashmap, "Russie", "Moscou");
  hashmap_put(&hashmap, "Corée du Sud", "Séoul");
  hashmap_put(&hashmap, "Indonésie", "Jakarta");
  hashmap_put(&hashmap, "Bangladesh", "Dacca");
  hashmap_put(&hashmap, "Mexique", "Mexico");
  hashmap_put(&hashmap, "Royaume-Uni", "Londres");
  hashmap_put(&hashmap, "Pérou", "Lima");
  hashmap_put(&hashmap, "Thaïlande", "Bangkok");
  hashmap_put(&hashmap, "Iran", "Téhéran");
  hashmap_put(&hashmap, "Colombie", "Bogota");
  hashmap_put(&hashmap, "Égypte	Le", "Caire");
  hashmap_put(&hashmap, "Iraq", "Bagdad");
  hashmap_put(&hashmap, "Singapour", "Singapour");
  hashmap_put(&hashmap, "Turquie", "Ankara");
  hashmap_put(&hashmap, "Chili", "Santiago");
  hashmap_put(&hashmap, "Arabie saoudite", "Riyad");
  hashmap_put(&hashmap, "Algérie", "Alger");
  hashmap_put(&hashmap, "Allemagne", "Berlin");
  hashmap_put(&hashmap, "Syrie", "Damas");
  hashmap_put(&hashmap, "Viêt Nam", "Hanoï");
  hashmap_put(&hashmap, "Espagne", "Madrid");
  hashmap_put(&hashmap, "Corée du Nord", "Pyongyang");
  hashmap_put(&hashmap, "Afghanistan", "Kaboul");
  hashmap_put(&hashmap, "Kenya", "Nairobi");
  hashmap_put(&hashmap, "Éthiopie", "Addis-Abeba");
  hashmap_put(&hashmap, "Argentine", "Buenos Aires");
  hashmap_put(&hashmap, "Italie", "Rome");
  hashmap_put(&hashmap, "Ukraine", "Kiev");
  hashmap_put(&hashmap, "Taïwan", "Taipei");
  hashmap_put(&hashmap, "Brésil", "Brasília");
  hashmap_put(&hashmap, "Jordanie", "Amman");
  hashmap_put(&hashmap, "Angola", "Luanda");
  hashmap_put(&hashmap, "Afrique du Sud", "Pretoria");
  hashmap_put(&hashmap, "France", "Paris");
  hashmap_put(&hashmap, "Ouzbékistan", "Tachkent");
  hashmap_put(&hashmap, "Azerbaïdjan", "Bakou");
  hashmap_put(&hashmap, "Suède", "Stockholm");
  hashmap_put(&hashmap, "Cuba", "La Havane");
  hashmap_put(&hashmap, "Cambodge", "Phnom Penh");
  hashmap_put(&hashmap, "Roumanie", "Bucarest");
  hashmap_put(&hashmap, "Venezuela", "Caracas");
  hashmap_put(&hashmap, "Maroc", "Rabat");
  hashmap_put(&hashmap, "Autriche", "Vienne");
  hashmap_put(&hashmap, "Soudan", "Khartoum");
  hashmap_put(&hashmap, "Hongrie", "Budapest");
  hashmap_put(&hashmap, "Pologne", "Varsovie");
  hashmap_put(&hashmap, "Biélorussie", "Minsk");

  printf("\n# Testing hashmap_get\n");
  printf("\n## Searching for an existing entry. This should print \"Capital of %s is %s\"\n",
	 "France", "Paris");  
  print_capital_city(&hashmap, "France");

  printf("\n## Searching for an existing entry. This should print \"Capital of %s is %s\"\n",
	 "Royaume-Uni", "Londres");
  print_capital_city(&hashmap, "Royaume-Uni");


  printf("\n## Searching for an non-existing entry. This should print \"Cannot find the Capital of %s\"\n",
	 "Portugal");
  print_capital_city(&hashmap, "Portugal");

  printf("\n# Testing hashmap_finalize\n");
  hashmap_finalize(&hashmap);

  return EXIT_SUCCESS;
}
